$IFNDEF _CGI_NEW_INC
$DEFINE _CGI_NEW_INC
'CGI_NEW.INC
'Version 1.5 25-SEPT-2003
'2001-2003 Chris Warrington
'	rapidq.basic.c45207@spamgourmet.com
'
'Uses some modifications by C. Baker <yahoojunk@pacific-steel.com> (18-SEPT-2003):
' - Only one pass through the query string
' - Replaced a do/while loop with the faster for/next loop
'
'This library is free software. You may use according to the following conditions:
' 1) USE of this library is free. You may use this library however you wish,
'    whether it be for your own private use or for commercial use or anything else.
' 2) If you make any modifications to this library, you MUST release those
'    modifications to the RapidQ community.
' 3) Although you may use this library, it is still copyrighted 2003 Chris
'    Warrington.

$IFNDEF CGI_MAX_INPUT
	$DEFINE CGI_MAX_INPUT 32767
$ENDIF

DEFSTR CGI_pairs$(0 TO 255, 0 TO 1)
CONST CGI_MAXPAIRS = 256
CONST CGI_ID = 0
CONST CGI_VALUE = 1
DEFINT CGI_total& = 0
DEFSTR CGI_QueryString$ = ""
'--------------------
'--- CGI ENV Vars ---
'--------------------
CONST CGI_Accept = ENVIRON$("HTTP_ACCEPT")
CONST CGI_AuthType = ENVIRON$("AUTH_TYPE")
CONST CGI_ContentLength = VAL(ENVIRON$("CONTENT_LENGTH"))
CONST CGI_ContentType = ENVIRON$("CONTENT_TYPE")
CONST CGI_Cookie = ENVIRON$("HTTP_COOKIE")
CONST CGI_GatewayInterface = ENVIRON$("GATEWAY_INTERFACE")
CONST CGI_PathInfo = ENVIRON$("PATH_INFO")
CONST CGI_PathTranslated =ENVIRON$("PATH_TRANSLATED")
CONST CGI_Referer = ENVIRON$("HTTP_REFERER")
CONST CGI_RemoteAddr = ENVIRON$("REMOTE_ADDR")
CONST CGI_RemoteHost = ENVIRON$("REMOTE_HOST")
CONST CGI_RemoteIdent = ENVIRON$("REMOTE_IDENT")
CONST CGI_RemoteUser = ENVIRON$("REMOTE_USER")
CONST CGI_RequestMethod = ENVIRON$("REQUEST_METHOD")
CONST CGI_ScriptName = ENVIRON$("SCRIPT_NAME")
CONST CGI_ServerSoftware = ENVIRON$("SERVER_SOFTWARE")
CONST CGI_ServerName = ENVIRON$("SERVER_NAME")
CONST CGI_ServerPort = ENVIRON$("SERVER_PORT")
CONST CGI_ServerProtocol = ENVIRON$("SERVER_PROTOCOL")
CONST CGI_UserAgent = ENVIRON$("HTTP_USER_AGENT")

'Figure out from where we should get the input
IF UCASE$(CGI_RequestMethod) = "POST" THEN
	'Make sure we don't have too much...
	IF CGI_ContentLength > CGI_MAX_INPUT THEN
		CGI_QueryString$ = GET$(CGI_MAX_INPUT)
	ELSE
		CGI_QueryString$ = GET$(CGI_ContentLength)
	END IF
ELSE
	IF LEN(ENVIRON$("QUERY_STRING")) > CGI_MAX_INPUT THEN
		CGI_QueryString$ = LEFT$(ENVIRON$("QUERY_STRING"), CGI_MAX_INPUT)
	ELSE
		CGI_QueryString$ = ENVIRON$("QUERY_STRING")
	END IF
END IF

'-----------------------------------------
'--- CGI_SpaceReplace(line$) AS STRING ---
'-----------------------------------------
FUNCTION CGI_SpaceReplace(line$ AS STRING) AS STRING
	DEFINT i
	FOR i = TO LEN(line$)
		IF MID$(line$, i, 1) = "+" THEN
			IF i + 1 <= LEN(line$) THEN
				IF (MID$(line$, i + 1, 1) <> "+" AND MID$(line$, i + 1, 1) <> " ") THEN 'only replace + with a space when it is not followed by another + or space
					line$ = REPLACE$(line$, " ", i)
				END IF
			END IF
		END IF
	NEXT i
	CGI_SpaceReplace = line$
END FUNCTION

'---------------------------------------
'--- CGI_HexReplace(line$) AS STRING ---
'---------------------------------------
FUNCTION CGI_HexReplace(line$ AS STRING) AS STRING
	DEFINT i = 1, length = LEN(line$)
	WHILE i <= length
		IF MID$(line$, i, 1) = "%" THEN
			IF i + 2 <= LEN(line$) THEN 'look ahead
				DEFSTR hexadecimal$ = MID$(line$, i + 1, 2)
				DEFSTR decimal$ = CONVBASE$(UCASE$(hexadecimal$), 16, 10)
				IF (VAL(decimal$) >= ASC(" ") AND VAL(decimal$) <= ASC("~")) THEN 'make sure it is a "printable" character
					line$ = REPLACE$(line$, CHR$(VAL(decimal$)), i)
					DEFSTR a$ = MID$(line$, 1, i) 'seperate the line into the parts before and after the %xx
					DEFSTR b$ = MID$(line$, i + 3, LEN(line$) - LEN(a$) - 2)
					line$ = a$ + b$
				END IF
			END IF
		END IF
		i++
		length = LEN(line$)
	WEND
	CGI_HexReplace = line$
END FUNCTION

'--------------------------------------------------------
'--- CGI_LookAhead(preview&, line$, index&) AS STRING ---
'--------------------------------------------------------
FUNCTION CGI_LookAhead(preview& AS INTEGER, line$ AS STRING, index& AS INTEGER) AS STRING
	CGI_LookAhead = ""
	IF (index& + preview&) > LEN(line$) THEN 'make sure we can look ahead
		EXIT FUNCTION
	ELSE
		CGI_LookAhead = MID$(line$, index& + 1, preview&) 'look ahead preview& from, but not including, index&
	END IF
END FUNCTION

'-----------------------------------------
'--- CGI_SimpleDeHex(chars$) AS STRING ---
'-----------------------------------------
FUNCTION CGI_SimpleDeHex(chars$ AS STRING) AS STRING
	CGI_SimpleDeHex = ""
	IF LEN(chars$) <> 2 THEN 'make sure we don't have too many or too few
		EXIT FUNCTION
	ELSE
		DEFINT charAsc = VAL(CONVBASE$(UCASE$(chars$), 16, 10))
		IF (charAsc >= ASC(" ") AND charAsc <= ASC("~")) THEN 'make sure it is a "printable" character
			CGI_SimpleDeHex = CHR$(charAsc)
		END IF
	END IF
END FUNCTION

'------------------------------------------------------------
'--- CGI_AddToPair(pairNum&, fieldNum&, chars$) AS STRING ---
'------------------------------------------------------------
FUNCTION CGI_AddToPair(pairNum& AS INTEGER, fieldNum& AS INTEGER, chars$ AS STRING) AS STRING
	IF (pairNum& >= 0 AND pairNum& < CGI_MAXPAIRS) THEN
		IF (fieldNum& = CGI_ID OR fieldNum& = CGI_VALUE) THEN
			IF LEN(chars$) > 0 THEN
			CGI_pairs$(pairNum&, fieldNum&) = CGI_pairs$(pairNum&, fieldNum&) + chars$ 'add iff pairNum& and fileNum& are valid
			END IF
		END IF
	END IF
END FUNCTION

'---------------------
'--- InitCgi(void) ---
'---------------------
SUB InitCgi()
	DEFINT queryStringLength& = LEN(CGI_QueryString$) 'Calculate this now so it is faster when we look it up later
	IF queryStringLength& > 0 THEN 'No CGI_QueryString$; don't process
		DEFINT queryStringIndex& 'CGI_QueryString index
		DEFINT pairIndex& = 0  'CGI_pair index -- to determine if we are using the id, CGI_pair$(x, CGI_ID), or the value, CGI_pair$(x, CGI_VALUE)
		CGI_pairs$(CGI_total&, CGI_ID) = ""
		CGI_pairs$(CGI_total&, CGI_VALUE) = ""
		CGI_total& = 1

		FOR queryStringIndex& = 1 TO queryStringLength&
			DEFSTR char$ = MID$(CGI_QueryString$, queryStringIndex&, 1) 'the character to process
			IF char$ = "&" THEN
				IF CGI_total& + 1 <= CGI_MAXPAIRS THEN 'Max sure the new pair doesn't put us over the limit
					pairIndex& = CGI_ID 'Initialize the next pair in CGI_pair$; insure we're using pairIndex& of CGI_ID
					CGI_pairs$(CGI_total&, CGI_ID) = ""
					CGI_pairs$(CGI_total&, CGI_VALUE) = ""
					CGI_total&++
				ELSE  'We've hit our limit; no more pairs
					'queryStringIndex& = queryStringLength&
					EXIT FOR
				END IF 'CGI_total& < CGI_MaxPairs
			ELSEIF char$ = "=" THEN
				pairIndex& = CGI_VALUE	'Switch from storing in the id to storing in the value
			ELSE ' not a control character (= or &) so add it to the CGI_pair
				$IFDEF CGI_NO_CONVERT
				CGI_AddToPair(CGI_total& - 1, pairIndex&, char$)
				$ELSE
				IF char$ = "%" THEN
					DEFSTR converted$ = CGI_SimpleDeHex(CGI_LookAhead(2, CGI_QueryString$, queryStringIndex&))
					IF (converted$) <> "" THEN
						CGI_AddToPair(CGI_total& - 1, pairIndex&, converted$)
						queryStringIndex& = queryStringIndex& + 2 'advance index to proper position
					ELSE
						CGI_AddToPair(CGI_total& - 1, pairIndex&, char$)
					END IF
				$IFNDEF CGI_NO_SPACE_CONVERT
				ELSEIF char$ = "+" THEN
					DEFSTR lookAhead$ = CGI_LookAhead(1, CGI_QueryString$, queryStringIndex&)
					IF (lookAhead$ = "+" OR lookAhead$ = " ") THEN
						CGI_AddToPair(CGI_total& - 1, pairIndex&, "+")
					ELSE
						CGI_AddToPair(CGI_total& - 1, pairIndex&, " ")
					END IF
				$ENDIF	
				ELSE
					CGI_AddToPair(CGI_total& - 1, pairIndex&, char$)
				END IF
				$ENDIF
			END IF
		NEXT queryStringIndex&
	END IF  'queryStringLength > 0
END SUB 'InitCgi

'------------------------
'--- GetCgiValue(id$) ---
'------------------------
FUNCTION GetCgiValue(id$ AS STRING) AS STRING
	DEFINT i

	GetCgiValue = ""
	FOR i = 0 TO CGI_total& - 1
		IF CGI_pairs$(i, CGI_ID) = id$ THEN
			GetCgiValue = CGI_pairs$(i, CGI_VALUE)
			EXIT FOR
		END IF
	NEXT i
END FUNCTION

$ENDIF '$IFNDEF _CGI_NEW_INC